without trace
without warning
include except.e

global type complex(object theObject)
    if sequence(theObject) and length(theObject)=2
    and atom(theObject[1]) and atom(theObject[2]) then
        return TRUE
    end if
    return FALSE
end type

function test_overflow(complex a)
    complex b
    integer flag
    b={0,0}
    flag=FALSE
    for i=1 to 2 do
        if a[i]<-1e300 then
	    b[i]=-1e300
	    flag=TRUE
        elsif a[i]>1e300 then
	    b[i]=1e300
	    flag=TRUE
        else
	    b[i]=a[i]
        end if
    end for
    if flag=TRUE then throw({"Overflow","Complex_Math_Error"}) end if
    return b
end function

global function complex_add(complex a,complex b)
    complex c
    c={0,0}
    for i=1 to 2 do
        c[i]=a[i]+b[i]
    end for
    return test_overflow(c)
end function

global function complex_negate(complex a)
    return {-a[1],-a[2]}
end function

global function complex_conjugate(complex a)
    return {a[1],-a[2]}
end function

global function complex_subtract(complex a,complex b)
    return complex_add(a,complex_negate(b))
end function

global function complex_multiply(complex a, complex b)
    complex c
    c={0,0}
    c[1]=a[1]*b[1]-a[2]*b[2]
    c[2]=a[1]*b[2]+a[2]*b[1]
    return test_overflow(c)
end function

global function complex_divide(complex a, complex b)
    complex c
    atom denom
    if equal(b,{0,0}) then
        throw({"Zero_Divide","Complex_Math_Error"})
        return {0,0}
    end if
    c={0,0}
    denom=power(b[1],2)+power(b[2],2)
    c[1]=(a[1]*b[1]+a[2]*b[2])/denom
    c[2]=(a[2]*b[1]-a[1]*b[2])/denom
    return test_overflow(c)
end function

global function complex_abs(complex a)
    return sqrt(power(a[1],2)+power(a[2],2))
end function

