-- except.e Version 2.0
-- by Mike Nelson
-- mike-nelson-ODAAT@worldnet.att.net

-- JAVA-like exceptions
-- now may be selectively enabled/disabled
without trace
without warning

include utility.e

-- EXCEPTION HANDLING:
boolean ExceptionsEnabled
sequence PendingException,CaughtException
ExceptionsEnabled=TRUE
PendingException={}
CaughtException={}

global procedure fatal_error(object theError)
   if not string(theError) then
      printf(2,"\nUNKNOWN ERROR!!!\n",{})
   else
      printf(2,"\nERROR:  "&theError&"\n",{})
   end if
   ? 1/0
end procedure

global function exception()
   return not equal(PendingException,{})
end function

global procedure enable_exceptions(object Param)
   if not boolean(Param) then
      fatal_error("Invalid enable_exceptions parameter.")
   end if
   ExceptionsEnabled=Param
   if ExceptionsEnabled=FALSE and exception() then
      printf(2,"\nERROR:  exception handling disabled while\n",{})
      print(2,PendingException)
      printf(2,"\nexception was pending.\n",{})
      ? 1/0
   end if
end procedure

global procedure throw(object ExceptionList)
   if identifier(ExceptionList) then ExceptionList={ExceptionList} end if
   if not sequence_of_identifiers(ExceptionList)
   or length(ExceptionList)=0 then
      fatal_error("Invalid throw parameter.")
   end if
   if ExceptionsEnabled=FALSE then
      printf(2,"\nERROR:\n",{})
      print(2,ExceptionList)
      printf(2,"\nexception thrown while exception handling",{})
      printf(2," was disabled.\n",{})
      ? 1/0
   end if
   if exception() then
      printf(2,"\nERROR:\n",{})
      print(2,ExceptionList)
      printf(2,"\nexception thrown while\n",{})
      print(2,PendingException)
      printf(2,"\nexception was pending.\n",{})
      ? 1/0
   end if
   PendingException=ExceptionList
   CaughtException={}
end procedure

global function catch(object ExceptionList)
    if identifier(ExceptionList) then ExceptionList={ExceptionList} end if
    if not sequence_of_identifiers(ExceptionList) then
        fatal_error("Invalid catch parameter.")
    end if
    if not exception() then return FALSE end if
    if length(ExceptionList)=0 then
        CaughtException=PendingException
        PendingException={}
        return TRUE
    end if
    for i=1 to length(ExceptionList) do
        if find(ExceptionList[i],PendingException)!=0 then
	    CaughtException=PendingException
	    PendingException={}
	    return TRUE
        end if
    end for
    return FALSE
end function

global function caught()
    return CaughtException
end function

