-- utility.e Version 2.0
-- by Mike Nelson
-- mike-nelson-ODAAT@worldnet.att.net
-- modified to incorporate Gabriel Boehme's Print.e

without trace
without warning

include wildcard.e

-- BOOLEAN CONSTANTS:
global constant NO=0,FALSE=0,OFF=0,YES=1,TRUE=1,ON=1

-- USE TO DISCARD A RETURN VALUE
global object VOID

-- NEW TYPES:
global type boolean(object theObject)
   if integer(theObject) and theObject>=0 and theObject<=1 then
      return TRUE
   end if
   return FALSE
end type

global type character(object theObject)
   if integer(theObject) and theObject>=0 and theObject<=255 then
      return TRUE
   end if
   return FALSE
end type

global type string(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not character(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type identifier(object theObject)
   if sequence(theObject) and length(theObject)>0 then
      for i=1 to length(theObject) do
	 if not integer(theObject[i]) or upper(theObject[i])<'A'
	 or upper(theObject[i])>'Z' then
	    if find(theObject[i],"0123456789_")=0 or i=1 then
	       return FALSE
	    end if
	 end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_booleans(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not boolean(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_integers(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not integer(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_atoms(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not atom(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_strings(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not string(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_identifiers(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not identifier(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

global type sequence_of_sequences(object theObject)
   if sequence(theObject) then
      for i=1 to length(theObject) do
	 if not sequence(theObject[i]) then return FALSE end if
      end for
      return TRUE
   end if
   return FALSE
end type

-- Note: an empty sequence {} will test true for all sequence_of_ types.

-- UTILITY FUNCTIONS:
global function find_duplicate(object theObject)
   if atom(theObject) or length(theObject)<2 then return 0 end if
   for i=2 to length(theObject) do
      for j=1 to i-1 do
	 if equal(theObject[i],theObject[j]) then
	    return j
	 end if
      end for
   end for
   return 0
end function

global function remove(object theObject,object index)
   if atom(theObject) or not integer(index) or index<1
   or index>length(theObject) then
      return theObject
   end if
   return theObject[1..index-1]&theObject[index+1..length(theObject)]
end function

global procedure delay(atom seconds)
   atom t1,t2
   t1=time()
   t2=0
   while t2<seconds do
      t2=time()-t1
      if t2<0 then t2+=86400 end if  -- midnight wraparound
   end while
end procedure

constant ESCAPE_STRING = {"\\n", "\\t", "\\\"", "\\\\", "\\r"},
	 ESCAPED_CHARS = {'\n',  '\t',  '"',    '\\',   '\r'}

procedure eu_print(integer file,atom theAtom)
   print(file,theAtom)
end procedure

procedure print_string(integer file,string theString)
   integer index
   puts(file,'"')
   for i=1 to length(theString) do
      index=find(theString[i],ESCAPED_CHARS)
      if index!=0 then
	 puts(file,ESCAPE_STRING[index])
      else
	 puts(file,theString[i])
      end if
   end for
   puts(file,'"')
end procedure

procedure print_sequence(integer file,sequence theSequence)
   if string(theSequence) then print_string(file,theSequence) return end if
   puts(file,'{')
   for i=1 to length(theSequence) do
      if atom(theSequence[i]) then
	 eu_print(file,theSequence[i])
      elsif string(theSequence[i]) then
	 print_string(file,theSequence[i])
      else
	 print_sequence(file,theSequence[i])
      end if
      if i<length(theSequence) then puts(file,',') end if
   end for
   puts(file,'}')
end procedure

global procedure print(integer file,object theObject)
   if atom(theObject) then eu_print(file,theObject) return end if
   print_sequence(file,theObject)
end procedure
-- The print procedure is by Gabriel Boehme (C) 1999.  The only substantial
-- modification of his code is to allow characters 0-31 in strings.  All
-- other modifications are purely stylistic.

